unit Cursors;
{ প ஢
}

{$A-,B-,F-,I+,R-,S+,V-}

interface

uses Memory,Crt,KeyStrok,Graph,Windows;

type
  CursorRec=object
              col: byte;
              x,y: word;
              constructor Create(setcol:byte);
              destructor Destroy; virtual;
              procedure Draw; virtual;
              procedure Hide; virtual;
            end;
  cursor=^CursorRec;

function NoCursor:cursor;
function XCursor(col:byte; size:word):cursor;
function FrameCursor(col:byte; size:word):cursor;
function ExpandingCursor(col:byte; x,y:word):cursor;
procedure DestroyCursor(var cur:cursor);
procedure GetCursor(win:window; cur:cursor; var x,y:word);

implementation

{********** cursor objects *************}

type
  XCursorRec=object(CursorRec)
               size: word;
               constructor Create(setcol:byte; setsize:word);
               destructor Destroy; virtual;
               procedure Draw; virtual;
             end;
  FrameCursorRec=object(CursorRec)
                   size: word;
                   constructor Create(setcol:byte; setsize:word);
                   destructor Destroy; virtual;
                   procedure Draw; virtual;
                 end;
  ExpandingCursorRec=object(CursorRec)
                       xinit,yinit: word;
                       constructor Create(setcol:byte; setx,sety:word);
                       destructor Destroy; virtual;
                       procedure Draw; virtual;
                     end;

constructor CursorRec.Create(setcol:byte);
begin
  col:=setcol; x:=0; y:=0;
end;

destructor CursorRec.Destroy;
begin
end;

procedure CursorRec.Draw;
begin
end;

procedure CursorRec.Hide;
begin
  Draw
end;

function NoCursor:cursor;
var
  p: cursor;
begin
  New(p,Create(0)); NoCursor:=p
end;

constructor XCursorRec.Create(setcol:byte; setsize:word);
begin
  CursorRec.Create(setcol); size:=setsize;
end;

destructor XCursorRec.Destroy;
begin
end;

procedure XCursorRec.Draw;
var
  xbeg,ybeg: word;
begin
  SetWriteMode(XORPut); SetColor(col);
  if x<size then xbeg:=0 else xbeg:=x-size;
  if y<size then ybeg:=0 else ybeg:=y-size;
  Line(xbeg,y,x+size,y); Line(x,ybeg,x,y+size);
  SetWriteMode(NormalPut)
end;

function XCursor(col:byte; size:word):cursor;
var
  p: ^XCursorRec;
begin
  New(p,Create(col,size)); XCursor:=p
end;

constructor FrameCursorRec.Create(setcol:byte; setsize:word);
begin
  CursorRec.Create(setcol); size:=setsize;
end;

destructor FrameCursorRec.Destroy;
begin
end;

procedure FrameCursorRec.Draw;
var
  xbeg,ybeg: word;
begin
  SetWriteMode(XORPut); SetColor(col);
  if x<size then xbeg:=0 else xbeg:=x-size;
  if y<size then ybeg:=0 else ybeg:=y-size;
  MoveTo(xbeg,ybeg); LineTo(xbeg,y+size); LineTo(x+size,y+size);
  LineTo(x+size,ybeg); LineTo(xbeg,ybeg);
  SetWriteMode(NormalPut)
end;

function FrameCursor(col:byte; size:word):cursor;
var
  p: ^FrameCursorRec;
begin
  New(p,Create(col,size)); FrameCursor:=p
end;

constructor ExpandingCursorRec.Create(setcol:byte; setx,sety:word);
begin
  CursorRec.Create(setcol); xinit:=setx; yinit:=sety;
end;

destructor ExpandingCursorRec.Destroy;
begin
end;

procedure ExpandingCursorRec.Draw;
begin
  SetWriteMode(XORPut); SetColor(col);
  MoveTo(xinit,yinit); LineTo(xinit,y); LineTo(x,y);
  LineTo(x,yinit); LineTo(xinit,yinit);
  SetWriteMode(NormalPut)
end;

function ExpandingCursor(col:byte; x,y:word):cursor;
var
  p: ^ExpandingCursorRec;
begin
  New(p,Create(col,x,y)); ExpandingCursor:=p
end;

{********** main procedure *************}

procedure GetCursor(win:window; cur:cursor; var x,y:word);
var
  key: word;
  maxx,maxy: word;
begin
  SelectWindow(win); maxx:=GetWidth(win)-1; maxy:=GetHeight(win)-1;
  if cur^.x>maxx then cur^.x:=maxx;
  if cur^.y>maxy then cur^.y:=maxy;
  repeat
    cur^.Draw;
    repeat until KeyPressed;
    key:=ReadKey;
    cur^.Hide;
    if Hi(key)<>0 then begin
      case Hi(key) of
        Hi(UpKey):       if cur^.y<>0 then Dec(cur^.y);
        Hi(DownKey):     if cur^.y<>maxy then Inc(cur^.y);
        Hi(LeftKey):     if cur^.x<>0 then Dec(cur^.x);
        Hi(RightKey):    if cur^.x<>maxx then Inc(cur^.x);
        Hi(HomeKey):     if (cur^.x<>0) and (cur^.y<>0) then begin
                           Dec(cur^.x); Dec(cur^.y)
                         end;
        Hi(EndKey):      if (cur^.x<>0) and (cur^.y<>maxy) then begin
                           Dec(cur^.x); Inc(cur^.y);
                         end;
        Hi(PageUpKey):   if (cur^.x<>maxx) and (cur^.y<>0) then begin
                           Inc(cur^.x); Dec(cur^.y)
                         end;
        Hi(PageDownKey): if (cur^.x<>maxx) and (cur^.y<>maxy) then begin
                           Inc(cur^.x); Inc(cur^.y)
                         end;
      end;
    end;
  until (key=EnterKey) or (key=DeleteKey);
  x:=cur^.x; y:=cur^.y;
{   if (key=DeleteKey) then cur^.Destroy;}
end;

procedure DestroyCursor(var cur:cursor);
begin
  Dispose(cur,Destroy)
end;

begin
end.