unit Messages;
{饭}

{$A-,B-,F-,I+,R-,S+,V-,N-}

interface

uses Crt,Keystrok,Memory,Graph,Chars14,Windows;

type
  CharSet=set of char;
  HelpProcType=procedure (helpid:word);

const
  SpecialKeysNumber=8;
  TopPrompt=true;
  BottomPrompt=false;

const
  TextOffsetX: word=5;
  TextOffsetY: word=1;
  HelpKey: word=F1Key;

var
  HelpProc: HelpProcType;
  Escaped: boolean;

procedure Message(mess:string; frm:frame; bkcol,txtcol:byte; helpid:word);

procedure Prompt(win:window; mess:string; bkcol,txtcol:byte; top:boolean);

function AskKey(mess:string; frm:frame; bkcol,txtcol:byte; helpid:word):word;

function Ask(mess:string; frm:frame; bkcol,txtcol:byte; helpid:word):boolean;

function AskInt(mess:string; frm:frame; bkcol,txtcol,anscol:byte; pos:byte;
                  helpid:word):longint;

function AskReal(mess:string; frm:frame; bkcol,txtcol,anscol:byte;
                   pos:byte; helpid:word):real;

function AskString(mess:string; frm:frame; bkcol,txtcol,anscol:byte;
                     pos:byte; helpid:word):string;

procedure InputInt(var obj:integer; mess:string; frm:frame; bkcol,txtcol,
                     anscol:byte; pos:byte; helpid:word);

procedure InputReal(var obj:real; mess:string; frm:frame; bkcol,txtcol,
                     anscol:byte; pos,dec:byte; helpid:word);

procedure InputWord(var obj:word; mess:string; frm:frame; bkcol,txtcol,
                      anscol:byte; pos:byte; helpid:word);

procedure InputByte(var obj:byte; mess:string; frm:frame; bkcol,txtcol,
                      anscol:byte; pos:byte; helpid:word);

procedure InputString(var obj:string; mess:string; frm:frame; bkcol,txtcol,
                       anscol:byte; pos:byte; helpid:word);

procedure InputEnum(var obj; mess:string; frm:frame; bkcol,txtcol,anscol:byte;
                       var desc; num,length:byte; helpid:word);

{************* for use in Menus etc. *****************}

procedure OrgHelpProc(helpid:word);

procedure NothingToDo(helpid:word);

procedure AddSpecialKey(key:word);

procedure RemoveSpecialKey(key:word);

procedure EnterString(var obj:string; anscol,pos:byte; start:word;
                        allow: CharSet; var key:word; helpid:word);

procedure EnterEnum(var obj; anscol:byte; var desc; num,length:byte;
                      start:word; var key:word; helpid:word);

function SpecialKey(key:word):boolean;

function ConvertFromInteger(val:longint; pos:byte):string;

function ConvertFromReal(x:real; pos,dec:byte):string;

implementation

type
  KeyType=(NoKey,SimpleKey,CursorKey,SpecKey,HlpKey);

var
  MessageWindow: window;
  SpecialKeys: array[1..SpecialKeysNumber] of word;

{**************** internal routines *****************}

function MessageSpace(mess:string; frm:frame; bkcol:byte; sp:byte):
                        word;
var
  width,height,xbeg,ybeg:word;
begin
  width:=(Length(mess)+sp)*CharWidth+2*TextOffsetX;
  height:=CharHeight+2*TextOffsetY;
  if (width>ScreenMaxX) then
       FatalError('饭  室  ⢥  ');
  xbeg:=(ScreenMaxX-width) div 2; ybeg:=(ScreenMaxY-height) div 2;
  MakeWindowInt(MessageWindow,xbeg,xbeg+width-1,ybeg,ybeg+height-1,frm,
                  bkcol,Foreground,EraseOn,CloseOff);
  MessageSpace:=Length(mess)*CharWidth+TextOffsetX
end;

procedure DrawMessage(mess:string; txtcol:byte);
begin
  SelectWindow(MessageWindow);
  SetColor(txtcol);
  OutTextXY(TextOffsetX,TextOffsetY,mess);
end;

procedure DeleteMessage;
begin
  CloseWindow(MessageWindow);
end;

procedure DestroyMessage;
begin
  DestroyWindow(MessageWindow);
end;

function SpecialKey(key:word):boolean;
var
  i:byte;
begin
  for i:=1 to SpecialKeysNumber do begin
    if key=SpecialKeys[i] then begin
      SpecialKey:=true; Exit
    end
  end;
  SpecialKey:=false
end;

{**************** external routines *****************}

function ConvertFromInteger(val:longint; pos:byte):string;
var
  s: string;
  i: byte;
begin
  Str(val:pos,s);
  if Length(s)>pos then begin
    s[0]:=Chr(pos);
    for i:=1 to pos do s[i]:='*';
  end;
  while s[1]=' ' do Delete(s,1,1);
  ConvertFromInteger:=s
end;

{function ConvertFromReal(val:real; pos,dec:byte):string;
var
  s: string;
  i: byte;
begin
  Str(val:pos:dec,s);
  if Length(s)>pos then Str(val:pos,s);
  while s[1]=' ' do Delete(s,1,1);
  if Length(s)>pos then begin
    s[0]:=Chr(pos);
    for i:=1 to pos do s[i]:='*';
  end;
  ConvertFromReal:=s;
end; }
function ConvertFromReal(x:real; pos,dec:byte):string;
var
  s,s1: string;
  i: byte;
  y: real;
  code : integer;
begin
  Str(x:pos:dec,s);
  val(s,y,code);
      if (y = 0) and (x <> 0.0) then Str(x:pos:pos,s);
  if Length(s)>pos then Str(x:pos,s);
  while s[1]=' ' do Delete(s,1,1);
  if Length(s)>pos then begin
    s[0]:=Chr(pos);
    for i:=1 to pos do s[i]:='*';
  end;
  ConvertFromReal:=s;
end;
procedure AddSpecialKey(key:word);
var
  i,j: byte;
begin
  j:=0;
  for i:=1 to SpecialKeysNumber do begin
    if key=SpecialKeys[i] then Exit;
    if (j=0) and (SpecialKeys[i]=0) then j:=i;
  end;
  if j<>0 then SpecialKeys[j]:=key
end;

procedure RemoveSpecialKey(key:word);
var
  i: byte;
begin
  for i:=1 to SpecialKeysNumber do begin
    if key=SpecialKeys[i] then begin
      SpecialKeys[i]:=0; Exit
    end
  end
end;

procedure Prompt(win:window; mess:string; bkcol,txtcol:byte; top:boolean);
var
  cnt,i: byte;
  lines: array[byte] of StringPtr;
  width: byte;
  work: string;
  y: word;
begin
  cnt:=0; i:=1;
  width:=GetWidth(win) div CharWidth;
  while i<Length(mess) do begin
    if mess[i]=^M then begin
      lines[cnt]:=AllocateString(Copy(mess,1,i-1)); Delete(mess,1,i); i:=1;
      if cnt<>0 then begin
        if Length(lines[cnt]^)+Length(lines[cnt-1]^)+1<=width then begin
          work:=lines[cnt-1]^+' '+lines[cnt]^;
          FreeString(lines[cnt-1]); FreeString(lines[cnt]);
          lines[cnt-1]:=AllocateString(work);
          Dec(cnt);
        end
      end;
      Inc(cnt)
    end else Inc(i)
  end;
  lines[cnt]:=AllocateString(mess);
  if cnt<>0 then begin
    if Length(lines[cnt]^)+Length(lines[cnt-1]^)+1<=width then begin
      work:=lines[cnt-1]^+' '+lines[cnt]^;
      FreeString(lines[cnt-1]); FreeString(lines[cnt]);
      lines[cnt-1]:=AllocateString(work);
      Dec(cnt);
    end
  end;
  SetColor(txtcol); SetFillStyle(SolidFill,bkcol); SelectWindow(win);
  if top then begin
    y:=TextOffsetY;
    Bar(0,0,GetWidth(win)-1,TextOffsetY+(cnt+1)*(CharHeight+TextOffsetY));
  end else begin
    y:=GetHeight(win)-(cnt+1)*(CharHeight+TextOffsetY);
    Bar(0,y-TextOffsetY,GetWidth(win)-1,GetHeight(win)-1);
  end;
  for i:=0 to cnt do begin
    OutTextXY(TextOffsetX,y,lines[i]^); FreeString(lines[i]);
    Inc(y,CharHeight+TextOffsetY)
  end;
end;

procedure Message(mess:string; frm:frame; bkcol,txtcol:byte; helpid:word);
var
  dummy: word;
  key: word;
begin
  dummy:=MessageSpace(mess,frm,bkcol,0);
  DrawMessage(mess,txtcol);
  repeat
    repeat until KeyPressed;
    key:=ReadKey;
    if key=HelpKey then OrgHelpProc(helpid);
  until key<>HelpKey;
  DestroyMessage
end;

function Ask(mess:string; frm:frame; bkcol,txtcol:byte; helpid:word):boolean;
var
  post: word;
  entered: boolean;
  key: word;
begin
  post:=MessageSpace(mess,frm,bkcol,6); DrawMessage(mess,txtcol);
  OutTextXY(post,TextOffsetY,'[Y/N]?');
  entered:=false; Escaped:=false;
  repeat
    repeat until KeyPressed;
    key:=ReadKey;
    if SpecialKey(key) then begin
      Ask:=false; Escaped:=true; entered:=true
    end else if key=HelpKey then OrgHelpProc(helpid) else begin
      case key of
        Ord('y'),Ord('Y'): begin
                             Ask:=true; entered:=true;
                           end;
        Ord('n'),Ord('N'): begin
                             Ask:=false; entered:=true;
                           end;
      end;
    end
  until entered;
  DestroyMessage
end;

function AskKey(mess:string; frm:frame; bkcol,txtcol:byte; helpid:word):word;
var
  post: word;
  entered: boolean;
  key: word;
begin
  post:=MessageSpace(mess,frm,bkcol,0); DrawMessage(mess,txtcol);
  Escaped:=false;
  repeat
    repeat until KeyPressed;
    key:=ReadKey; AskKey:=key; entered:=true;
    if SpecialKey(key) then Escaped:=true
    else if key=HelpKey then begin
      OrgHelpProc(helpid); entered:=false
    end;
  until entered;
  DestroyMessage
end;

function AskInt(mess:string; frm:frame; bkcol,txtcol,anscol:byte; pos:byte;
                  helpid:word):longint;
var
  buf: string;
  start: word;
  code: integer;
  work: longint;
  key: word;
begin
  buf:='';
  start:=MessageSpace(mess,frm,bkcol,pos);
  repeat
    code:=0; work:=0;
    DrawMessage(mess,txtcol);
    EnterString(buf,anscol,pos,start,['0'..'9','-'],key,helpid);
    if not Escaped then Val(buf,work,code);
    if code<>0 then begin
      Sound(2000); Delay(300); NoSound; DeleteMessage
    end;
  until code=0;
  DestroyMessage;
  AskInt:=work;
end;

function AskReal(mess:string; frm:frame; bkcol,txtcol,anscol:byte; pos:byte;
                   helpid:word):real;
var
  buf: string;
  start: word;
  code: integer;
  work: real;
  key: word;
begin
  buf:='';
  start:=MessageSpace(mess,frm,bkcol,pos);
  repeat
    code:=0; work:=0.0;
    DrawMessage(mess,txtcol);
    EnterString(buf,anscol,pos,start,['0'..'9','-','.','e','E'],key,helpid);
    if not Escaped then Val(buf,work,code);
    if code<>0 then begin
      Sound(2000); Delay(300); NoSound; DeleteMessage
    end;
  until code=0;
  DestroyMessage;
  AskReal:=work;
end;

function AskString(mess:string; frm:frame; bkcol,txtcol,anscol:byte;
                     pos:byte; helpid:word):string;
var
  buf: string;
  start: word;
  key: word;
begin
  buf:='';
  start:=MessageSpace(mess,frm,bkcol,pos);
  DrawMessage(mess,txtcol);
  EnterString(buf,anscol,pos,start,[Chr($20)..Chr($ff)],key,helpid);
  if Escaped then AskString:='' else AskString:=buf;
  DestroyMessage
end;

procedure InputInt(var obj:integer; mess:string; frm:frame; bkcol,txtcol,
                     anscol:byte; pos:byte; helpid:word);
var
  buf: string;
  start: word;
  code,work: integer;
  key: word;
begin
  buf:=ConvertFromInteger(obj,pos);
  start:=MessageSpace(mess,frm,bkcol,pos);
  repeat
    code:=0;
    DrawMessage(mess,txtcol);
    EnterString(buf,anscol,pos,start,['0'..'9','-'],key,helpid);
    if not Escaped then Val(buf,work,code);
    if code<>0 then begin
      Sound(2000); Delay(300); NoSound; DeleteMessage
    end;
  until code=0;
  DestroyMessage;
  if key=0 then obj:=work;
end;

procedure InputReal(var obj:real; mess:string; frm:frame; bkcol,txtcol,
                     anscol:byte; pos,dec:byte; helpid:word);
var
  buf: string;
  start: word;
  code: integer;
  work: real;
  key: word;
begin
  buf:=ConvertFromReal(obj,pos,dec);
  start:=MessageSpace(mess,frm,bkcol,pos);
  repeat
    code:=0;
    DrawMessage(mess,txtcol);
    EnterString(buf,anscol,pos,start,['0'..'9','-','.','e','E'],key,helpid);
    if not Escaped then Val(buf,work,code);
    if code<>0 then begin
      Sound(2000); Delay(300); NoSound; DeleteMessage
    end;
  until code=0;
  DestroyMessage;
  if key=0 then obj:=work;
end;

procedure InputWord(var obj:word; mess:string; frm:frame; bkcol,txtcol,
                      anscol:byte; pos:byte; helpid:word);
var
  buf: string;
  start,work: word;
  code: integer;
  key: word;
begin
  buf:=ConvertFromInteger(obj,pos);
  start:=MessageSpace(mess,frm,bkcol,pos);
  repeat
    code:=0;
    DrawMessage(mess,txtcol);
    EnterString(buf,anscol,pos,start,['0'..'9'],key,helpid);
    if not Escaped then Val(buf,work,code);
    if code<>0 then begin
      Sound(2000); Delay(300); NoSound; DeleteMessage
    end;
  until code=0;
  DestroyMessage;
  if key=0 then obj:=work;
end;

procedure InputByte(var obj:byte; mess:string; frm:frame; bkcol,txtcol,
                      anscol:byte; pos:byte; helpid:word);
var
  buf: string;
  start: word;
  code: integer;
  work: byte;
  key: word;
begin
  buf:=ConvertFromInteger(obj,pos);
  start:=MessageSpace(mess,frm,bkcol,pos);
  repeat
    code:=0;
    DrawMessage(mess,txtcol);
    EnterString(buf,anscol,pos,start,['0'..'9'],key,helpid);
    if not Escaped then Val(buf,work,code);
    if code<>0 then begin
      Sound(2000); Delay(300); NoSound; DeleteMessage
    end;
  until code=0;
  DestroyMessage;
  if key=0 then obj:=work;
end;

procedure InputString(var obj:string; mess:string; frm:frame; bkcol,txtcol,
                       anscol:byte; pos:byte; helpid:word);
var
  buf: string;
  start: word;
  key: word;
begin
  buf:=obj;
  start:=MessageSpace(mess,frm,bkcol,pos);
  DrawMessage(mess,txtcol);
  EnterString(buf,anscol,pos,start,[Chr($20)..Chr($ff)],key,helpid);
  if not Escaped then obj:=buf;
  DestroyMessage
end;

function EnterStroke(allow: CharSet; var key:word):KeyType;
const
  CursorMovings=[Hi(LeftKey),Hi(RightKey),Hi(HomeKey),Hi(EndKey),
                   Hi(DeleteKey),Hi(InsertKey)];
  CursorMovings2=[Lo(EnterKey),Lo(BackspaceKey)];
begin
  repeat until KeyPressed;
  key:=ReadKey;
  if key=HelpKey then EnterStroke:=HlpKey else
  if SpecialKey(key) then EnterStroke:=SpecKey else
  if (Hi(key) in CursorMovings) or (Lo(key) in CursorMovings2) then
        EnterStroke:=CursorKey else
  if (Hi(key)=0) and (Chr(Lo(key)) in allow) then EnterStroke:=SimpleKey else
  EnterStroke:=NoKey
end;

procedure EnterEnum(var obj; anscol:byte; var desc; num,length:byte;
                      start:word; var key:word; helpid:word);
type
  description=array[0..256] of byte;
var
  finish: word;
  s: string;
  p: ^byte;
  entered: boolean;
begin
  finish:=start+length*CharWidth-1;
  SetColor(anscol); SetFillStyle(SolidFill,CurWindow^.bkcol);
  Move(description(desc)[byte(obj)*(length+1)],s,length+1);
  OutTextXY(start,TextOffsetY,s);
  Escaped:=false; entered:=false; p:=@obj;
  repeat
    case EnterStroke([' '],key) of
      NoKey:     ;
      HlpKey:    OrgHelpProc(helpid);
      SpecKey:   begin
                   Escaped:=true;
                   Exit
                 end;
      CursorKey: case key of
                   LeftKey:  begin
                               Dec(p^); if p^>num-1 then p^:=num-1;
                               Bar(start,TextOffsetY,finish,
                                     TextOffsetY+CharHeight-1);
                               Move(description(desc)[byte(obj)*(length+1)],
                                      s,length+1);
                               OutTextXY(start,TextOffsetY,s);
                             end;
                   RightKey: begin
                               Inc(p^); if p^>num-1 then p^:=0;
                               Bar(start,TextOffsetY,finish,
                                     TextOffsetY+CharHeight-1);
                               Move(description(desc)[byte(obj)*(length+1)],
                                      s,length+1);
                               OutTextXY(start,TextOffsetY,s);
                             end;
                   EnterKey: begin
                               entered:=true;
                             end;
                 end;
      SimpleKey: if key=SpaceKey then begin
                   Inc(p^); if p^>num-1 then p^:=0;
                   Bar(start,TextOffsetY,finish,
                         TextOffsetY+CharHeight-1);
                   Move(description(desc)[byte(obj)*(length+1)],
                          s,length+1);
                   OutTextXY(start,TextOffsetY,s);
                 end;
    end;
  until entered;
  key:=0
end;

procedure InputEnum(var obj; mess:string; frm:frame; bkcol,txtcol,anscol:byte;
                       var desc; num,length:byte; helpid:word);
var
  start,key: word;
begin
  start:=MessageSpace(mess,frm,bkcol,length);
  DrawMessage(mess,txtcol);
  EnterEnum(obj,anscol,desc,num,length,start,key,helpid);
  DestroyMessage
end;

procedure EnterString(var obj:string; anscol,pos:byte; start:word;
                        allow: CharSet; var key:word; helpid:word);
var
  chpos: word;
  xorcol,strpos,i: byte;
  c: char;
  InsertMode: boolean;
  save: window;
procedure DrawCursor; {internal}
begin
  SetColor(xorcol);
  Line(chpos,TextOffsetY+CharHeight,chpos+CharWidth,TextOffsetY+CharHeight);
  if InsertMode then
    Line(chpos,TextOffsetY+CharHeight+1,chpos+CharWidth,
           TextOffsetY+CharHeight+1);
end; {internal procedure}
procedure DeleteChar(n: byte); {internal}
begin
  if n<>0 then
    Bar(chpos,TextOffsetY,chpos+n*CharWidth-1,TextOffsetY+CharHeight-1)
end; {internal procedure}
begin
  if Length(obj)>=pos then obj[0]:=Chr(pos);
  strpos:=1; chpos:=start;
  SetWriteMode(XorPut); xorcol:=anscol xor CurWindow^.bkcol;
  SetColor(anscol); SetFillStyle(SolidFill,CurWindow^.bkcol);
  OutTextXY(start,TextOffsetY,obj);
  InsertMode:=false; DrawCursor; Escaped:=false;
  repeat
    case EnterStroke(allow,key) of
      NoKey:     {nothing to do};
      SimpleKey: begin
                   c:=Chr(key);
                   if strpos<=Length(obj) then begin
                     if InsertMode then begin
                       DeleteChar(Length(obj)-strpos+1);
                       Insert(c,obj,strpos);
                       if Length(obj)>pos then obj[0]:=Chr(pos);
                       SetColor(anscol);
                       OutTextXY(chpos,TextOffsetY,
                         Copy(obj,strpos,Length(obj)-strpos+1))
                     end else begin
                       DeleteChar(1); SetColor(anscol);
                       obj[strpos]:=c; OutTextXY(chpos,TextOffsetY,c);
                     end
                   end else begin
                     obj:=obj+c; SetColor(anscol);
                     OutTextXY(chpos,TextOffsetY,c)
                   end;
                   if strpos<>pos then begin
                     DrawCursor; Inc(strpos); Inc(chpos,CharWidth);
                     DrawCursor
                   end;
                 end;
      SpecKey:   begin
                   Escaped:=true; SetWriteMode(NormalPut);
                   Exit
                 end;
      HlpKey:    begin
                   OrgHelpProc(helpid);
                   SetWriteMode(XorPut);
                 end;
      CursorKey: case key of
                   LeftKey:   if strpos>1 then begin
                                DrawCursor; Dec(strpos); Dec(chpos,CharWidth);
                                DrawCursor
                              end;
                   RightKey:  if (strpos<pos) and (strpos<=Length(obj)) then
                                    begin
                                DrawCursor; Inc(strpos); Inc(chpos,CharWidth);
                                DrawCursor
                              end;
                   HomeKey:   begin
                                DrawCursor; strpos:=1; chpos:=start;
                                DrawCursor
                              end;
                   EndKey:    begin
                                DrawCursor; strpos:=Length(obj)+1;
                                if strpos>pos then strpos:=pos;
                                chpos:=start+(strpos-1)*CharWidth;
                                DrawCursor;
                              end;
                   InsertKey: begin
                                DrawCursor;
                                InsertMode:=not InsertMode;
                                DrawCursor;
                              end;
                   DeleteKey: if strpos<=Length(obj) then begin
                                DeleteChar(Length(obj)-strpos+1);
                                Delete(obj,strpos,1);
                                SetColor(anscol);
                                OutTextXY(chpos,TextOffsetY,
                                    Copy(obj,strpos,Length(obj)-strpos+1));
                              end;
                   BackspaceKey: if strpos>1 then begin
                                   DrawCursor; Dec(strpos);
                                   Dec(chpos,CharWidth);
                                   DeleteChar(Length(obj)-strpos+1);
                                   Delete(obj,strpos,1);
                                   SetColor(anscol);
                                   OutTextXY(chpos,TextOffsetY,
                                       Copy(obj,strpos,Length(obj)-strpos+1));
                                   DrawCursor
                                 end;
                   EnterKey:  {exit};
                 end
    end
  until key=Enterkey;
  key:=0; SetWriteMode(NormalPut);
end;

procedure OrgHelpProc(helpid:word);
var
  save: window;
  col: word;
  fill: FillSettingsType;
begin
  save:=CurWindow;
  col:=GetColor;
  GetFillSettings(fill);
  HelpProc(helpid);
  SelectWindow(save);
  SetColor(col);
  SetFillStyle(fill.pattern,fill.color);
end;

procedure NothingToDo(helpid:word);
begin
end;

var
  work: byte;

begin
  SpecialKeys[1]:=$1b;
  for work:=2 to SpecialKeysNumber do SpecialKeys[work]:=0;
  HelpProc:=NothingToDo;
  MessageWindow:=nil;
end.
